// Standard C headers
#include <stdio.h>
#include <math.h>

int main(int argc, char **argv) {

	printf("Tests with pow:\n");
	double powResult = pow(-1004.3, 1e200);
	printf("pow(-1004.3, 1e200) = %f\n", powResult);
	
	if isinf(powResult) {
		printf("Overflow for pow(-1004.3, 1e200)\n");
	}

	powResult = pow(-34.84, 1e200);
	printf("pow(-34.84, 1e200) = %f\n", powResult);
	
	if isinf(powResult) {
		printf("Overflow for pow(-34.84, 1e200)\n");
	}

	powResult = pow(-1.2345678901234e+200, 1e200);
	printf("pow(-1.2345678901234e+200, 1e200) = %f\n", powResult);
	
	if isinf(powResult) {
		printf("Overflow for pow(-1.2345678901234e+200, 1e200)\n");
	}

	powResult = pow(-1.2345678901234e-200, 1e200);
	printf("pow(-1.2345678901234e-200, 1e200) = %f\n", powResult);
	
	if isinf(powResult) {
		printf("Overflow for pow(-1.2345678901234e-200, 1e200)\n");
	}


	printf("\nTests with multiplication for comparison:\n");
	double mulResult = -1004.3 * 1e200;
	printf("-1004.3 * 1e200 = %f\n", mulResult);
	
	if isinf(mulResult) {
		printf("Overflow for -1004.3 * 1e200\n");
	}

	mulResult = -34.84 * 1e200;
	printf("-34.84 * 1e200 = %f\n", mulResult);
	
	if isinf(mulResult) {
		printf("Overflow for -34.84 * 1e200\n");
	}

	mulResult = -1.2345678901234e+200 * 1e200;
	printf("-1.2345678901234e+200 * 1e200 = %f\n", mulResult);
	
	if isinf(mulResult) {
		printf("Overflow for -1.2345678901234e+200 * 1e200\n");
	}

	mulResult = -1.2345678901234e-200 * 1e200;
	printf("-1.2345678901234e-200 * 1e200 = %f\n", mulResult);
	
	if isinf(mulResult) {
		printf("Overflow for -1.2345678901234e-200 * 1e200\n");
	}
	
	return 0;

}
